#include "testlib.h"
#include <bits/stdc++.h>
using namespace std;

typedef long double ld;
typedef long long ll;
const int N = 50006;
const ld eps = 1e-10;

ll n, r, x[N], y[N];

bool inside(ld cx, ld cy, ld px, ld py, ld r) {
    return (cx - px) * (cx - px) + (cy - py) * (cy - py) <= r * r + eps;
}

int main(int argc, char** argv) {
    registerTestlibCmd(argc, argv);
    if (ans.readInt() == -1) {
        if (ouf.readInt() != -1) {
            quitf(_wa, "Find a non-exist solution for Kazuma OAO");
        }
        quitf(_ok, "AC ^_^. Kazuma loves you");
    }
    n = inf.readInt();
    r = inf.readInt();
    set< pair<ll, ll> > st;
    for (int i = 1; i <= n; ++i) {
        x[i] = inf.readInt();
        y[i] = inf.readInt();
        st.insert(make_pair(x[i], y[i]));
    }
    ll no_x = ouf.readInt();
    ll no_y = ouf.readInt();
    if (st.find(make_pair(no_x, no_y)) == st.end()) {
        quitf(_wa, "The tree is not exist!");
    }
    st.erase(st.find(make_pair(no_x, no_y)));
    ld expo_x = ouf.readDouble();
    ld expo_y = ouf.readDouble();
    if (inside(expo_x, expo_y, no_x, no_y, r)) {
        quitf(_wa, "Megumin kills herself QAQ");
    }
    for ( pair<ll, ll> p: st) {
        if (!inside(expo_x, expo_y, p.first, p.second, r)) {
            quitf(_wa, "Megumin can't explosion the tree QQ");
        }
    }
    quitf(_ok, "Megumin loves you <3");
}
